package com.jyz.api;

import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.gjjyz.tools.HttpUtils;
import com.jyz.base.encode.Hex;
import com.jyz.util.CommonUtil;

public class ApiTest {
	static public final String BASE_URL = "http://127.0.0.1:8080/jyz_new/jyzapi";
	static public final String USER_CODE = "test";
	static public final String PWD = "test";
	
	/**
	 * 	调用签名
	 * @param param
	 * @throws Exception
	 */
	public static void makeSign(String usercode, String pwd, Map<String, String> param) throws Exception{
		//添加通用参数
		param.put("usercode", usercode);
		param.put("timestamp", System.currentTimeMillis()/1000 + "");
		
		//对参数进行签名
		String sign = getSign(usercode, pwd, param);
		
		//签名结果放到参数中
		param.put("sign", sign);
	}
	
	public static String getSign(String usercode, String pwd, Map<String, String> params) throws Exception{
		//对key进行字典排序
		List<String> keyList = new ArrayList<String>();
		keyList.addAll(params.keySet());
		Collections.sort(keyList);
		
		//拼接签名内容
		String signString = "";
		for(String key:keyList) {
			if(key.equals("sign") || key.equals("key"))
				continue;
			
			if(params.get(key)==null)
				continue;
			
			signString += key + "=" + params.get(key) + "&";
		}
		signString += "key=" + pwd;
		
		//签名
		MessageDigest m = MessageDigest.getInstance("MD5");
		byte[] buff = m.digest(signString.getBytes("UTF-8"));
		String md5 = new String(Hex.encode(buff)).toUpperCase();
		
		return md5;
	}
	
	static public String getRemote(String url, Map<String, String> params) {
		Map<String, String> hearder = new HashMap<>();
		if(url.startsWith("https")) {
			return HttpUtils.doPostSSLPayload(url, CommonUtil.toJsonString(params), hearder);
		}else {
			return HttpUtils.doPostPayload(url, CommonUtil.toJsonString(params), hearder);
		}
	}
	
	public static void test_dqbm_list() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		param.put("ns_flag", "0");
		APIUtils.makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/dqbm/list";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(CommonUtil.jsonFormart(bodyString));
	}
	
	public static void test_yzpp_list() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/yzpp/list";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(bodyString);
	}
	
	public static void test_yqzl_list() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/yqzl/list";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(bodyString);
	}
	
	public static void test_fwlx_list() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/fwlx/list";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(bodyString);
	}
	
	public static void test_jyzxz_list() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/jyzxz/list";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(bodyString);
	}
	
	public static void test_default_yqzl() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		param.put("dqbm", "001");
		
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/default/yqzl";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(bodyString);
	}
	
	public static void test_jyz_list_around() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		param.put("lng", "114.39597291165");
		param.put("lat", "27.800623132826");
		param.put("platformFlag", "0");
		
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/jyz/list/around";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(CommonUtil.jsonFormart(bodyString));
	}
	
	public static void test_zdj_list() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		param.put("dqbm", "430000");
		param.put("ns_flag", "1");
		
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/zdj/list";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(CommonUtil.jsonFormart(bodyString));
	}
	
	public static void test_jyz_mx() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		param.put("id", "f18b41892d60fc8f012d73a1a7ea00c1");
		
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/jyz/mx";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(CommonUtil.jsonFormart(bodyString));
	}
	
	public static void test_jyz_list_bydq() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		param.put("dqbm", "430000");
		param.put("ns_flag", "1");
		
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/jyz/list/bydq";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(CommonUtil.jsonFormart(bodyString));
	}
	
	public static void test_jyz_list_update() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		param.put("pageSize", "50");
		param.put("pageIndex", "1");
		param.put("sdate", "20210115");
		
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/jyz/list/update";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(CommonUtil.jsonFormart(bodyString));
	}
	
	public static void test_jyz_list_delete() throws Exception{
		Map<String, String> param = new HashMap<String, String>();
		param.put("sdate", "20191115");
		
		makeSign(USER_CODE, PWD, param);
	
		String urlString = BASE_URL + "/jyz/list/delete";
		String bodyString = getRemote(urlString, param);
		
		System.out.println(CommonUtil.jsonFormart(bodyString));
	}
	
	public static void main(String[] args) throws Exception{
		test_zdj_list();
	}
}
